/********************************************************************************/
/*                                                                              */
/*  Netrinjo-Engine - a library for game-development                            */
/*  Copyright (C) 1999, 2000, 2005 by Tobias Nadler und Georg Schnattinger      */
/*                                                                              */
/*  This library is free software; you can redistribute it and/or               */
/*  modify it under the terms of the GNU Lesser General Public                  */
/*  License as published by the Free Software Foundation; either                */
/*  version 2.1 of the License, or (at your option) any later version.          */
/*                                                                              */
/*  This library is distributed in the hope that it will be useful,             */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/*  Lesser General Public License for more details.                             */
/*                                                                              */
/*  You should have received a copy of the GNU Lesser General Public            */
/*  License along with this library; if not, write to the Free Software         */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                              */
/********************************************************************************/

#ifndef GUITEXTFIELD_H
#define GUITEXTFIELD_H

#include "guibackground.h"
#include "guitext.h"

/**
\ingroup gui
\file guitextfield.h
\brief Defines the class GuiTextField
*/

class SdlSurface;

/**
\class GuiTextField
\brief A class to display moving text.
\todo this class is unfinished
*/
class DECLSPEC GuiTextField : public GuiFlowWindow
{
public:
	typedef SdlFont::HAlign HAlign;
	typedef SdlFont::VAlign VAlign;

	DECLSPEC GuiTextField(const SDL_Rect &r, GuiElement * el, const char *name, const char * t = 0, Uint32 c = CLR_INVALID, SdlImage * bgbmp = NULL);
	/**
	Constructor. Uses XML data.
	\param el the XML data for initialisation
	\param p parent element (or NULL, to take GuiManager::the as parent)
	\see GuiElement(TiXmlElement*,GuiElement*)
	*/
	DECLSPEC GuiTextField(TiXmlElement *el, GuiElement *p);
	virtual DECLSPEC ~GuiTextField();

	virtual const char *getClassName()	{ return "GuiTextField"; }
	
	void startMove(int t);
	void setText(const char * t);
	void setAlign(VAlign v, HAlign h);

	static void newguiobject(void *presult, BasicObject *o, void *xmldata)
	{
		GuiElement *r = new GuiTextField((TiXmlElement*)xmldata, (GuiElement*)o);
		*(GuiElement**)presult = r;
	}
protected:
	virtual DECLSPEC void onInit();
private:
	GuiText * gtext;
	int speed;
	HAlign ha;
	char * txt;
};

#endif
