/********************************************************************************/
/*                                                                              */
/*  Netrinjo-Engine - a library for game-development                            */
/*  Copyright (C) 1999, 2000, 2005 by Tobias Nadler und Georg Schnattinger      */
/*                                                                              */
/*  This library is free software; you can redistribute it and/or               */
/*  modify it under the terms of the GNU Lesser General Public                  */
/*  License as published by the Free Software Foundation; either                */
/*  version 2.1 of the License, or (at your option) any later version.          */
/*                                                                              */
/*  This library is distributed in the hope that it will be useful,             */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/*  Lesser General Public License for more details.                             */
/*                                                                              */
/*  You should have received a copy of the GNU Lesser General Public            */
/*  License along with this library; if not, write to the Free Software         */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                              */
/********************************************************************************/

#include "guiform.h"
#include <string>
#include "uitheme.h"
#include "thememanager.h"
#include "sdlmanager.h"
#include "guibackground.h"

using namespace std;

DECLARE_SLOT(new, GuiForm, GuiForm::newguiobject)

GuiForm::GuiForm( SDL_Rect &r, GuiElement *el, const char *name ): GuiBorder( r, el, name )
{
	SDL_Rect rr = r;
	rr.x = rr.y = 0;
	bg = new GuiPictureBg( rr, this, "" );
	
	onThemeChanged( ThemeManager::the ? ThemeManager::the->getActiveTheme() : NULL );
}

GuiForm::GuiForm( TiXmlElement *el, GuiElement *p ): GuiBorder( el, p )
{
	SDL_Rect rr = getRelWindow();
	rr.x = rr.y = 0;
	bg = new GuiPictureBg( rr, this, "" );
}

GuiForm::~GuiForm()
{
}

void GuiForm::onInit()
{
/*	TiXmlElement *el = getXmlData();
	if(el)	{
	}*/
	GuiBorder::onInit();
}

Uint32 GuiForm::onThemeChanged( UiTheme *t )
{
	Uint32 r = GuiBorder::onThemeChanged( t );
	if( t == 0 )
		return r;
	bg->bgcolor = t->getUint32( ((string)getClassName() + "->background-color").c_str() );
	bg->setBmp( SdlManager::the->getImageByName( t->getString( ((string)getClassName() + "->background-bmp").c_str() ) ) );
	
	return r;
}
