/********************************************************************************/
/*                                                                              */
/*  Netrinjo-Engine - a library for game-development                            */
/*  Copyright (C) 1999, 2000, 2005 by Tobias Nadler und Georg Schnattinger      */
/*                                                                              */
/*  This library is free software; you can redistribute it and/or               */
/*  modify it under the terms of the GNU Lesser General Public                  */
/*  License as published by the Free Software Foundation; either                */
/*  version 2.1 of the License, or (at your option) any later version.          */
/*                                                                              */
/*  This library is distributed in the hope that it will be useful,             */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/*  Lesser General Public License for more details.                             */
/*                                                                              */
/*  You should have received a copy of the GNU Lesser General Public            */
/*  License along with this library; if not, write to the Free Software         */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                              */
/********************************************************************************/

#include "guitextfield.h"
#include "sdlfont.h"
#include "sdlsurface.h"
#include "rectfunctions.h"

DECLARE_SLOT(new, GuiTextField, GuiTextField::newguiobject)

GuiTextField::GuiTextField( const SDL_Rect &r, GuiElement * el, const char *name, const char * t, Uint32 c, SdlImage * bgbmp )
	: GuiFlowWindow( r, el, name, c, bgbmp )
{
	eFlyStyle = constant;
	SDL_Rect gr;
	setRect( gr, 0, 0, r.w, r.h );
	gtext = new GuiText( gr, this, "", t );
}

GuiTextField::GuiTextField( TiXmlElement *el, GuiElement * p ): GuiFlowWindow( el, p )
{
	eFlyStyle = constant;
	SDL_Rect gr = getRelWindow();
	gr.x = gr.y = 0;
	gtext = new GuiText( gr, this, "", el->Attribute("Text") );
}

GuiTextField::~GuiTextField()
{

}

void GuiTextField::onInit()
{
	TiXmlElement *el = getXmlData();
	if(el)	{
		const char *str = el->Attribute("Text");
		if(str)
			gtext->setText(str);
	}
	GuiFlowWindow::onInit();
}

void GuiTextField::setText( const char *t )
{
	gtext->setText( t );
}

void GuiTextField::setAlign( VAlign v, HAlign h )
{
	gtext->setAlign( v, h );
}

void GuiTextField::startMove( int t )
{
/// \todo implement
	//set
}
