/********************************************************************************/
/*                                                                              */
/*  Netrinjo-Engine - a library for game-development                            */
/*  Copyright (C) 2005 by Tobias Nadler                                         */
/*                                                                              */
/*  This library is free software; you can redistribute it and/or               */
/*  modify it under the terms of the GNU Lesser General Public                  */
/*  License as published by the Free Software Foundation; either                */
/*  version 2.1 of the License, or (at your option) any later version.          */
/*                                                                              */
/*  This library is distributed in the hope that it will be useful,             */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/*  Lesser General Public License for more details.                             */
/*                                                                              */
/*  You should have received a copy of the GNU Lesser General Public            */
/*  License along with this library; if not, write to the Free Software         */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                              */
/********************************************************************************/

#include "webforwardpage.h"
#include <string.h>
#include "webserver.h"
#include "netmanager.h"
#include "basicapp.h"

WebForwardPage::WebForwardPage( const char *uri, const char *location ): WebPage( uri )
{
	chLocation = new char[strlen(location)+1];
	strcpy( chLocation, location );
}

WebForwardPage::~WebForwardPage()
{
	delete[] chLocation;
}
	
void WebForwardPage::setLocation( const char *l )
{
	delete[] chLocation;
	chLocation = new char[strlen(l)+1];
	strcpy( chLocation, l );
}

int WebForwardPage::send( WebSrvClient *client, Uint32 &responsecode )
{
	static const char *strBegin = "Location:";
	static const char *strEnd = "\r\n\r\n";
	char *chUri = new char[ strlen(chLocation) + strlen(strBegin) + strlen(strEnd) + 1 ];
	strcpy( chUri, strBegin );
	strcat( chUri, chLocation );
	strcat( chUri, strEnd );
	WebSrv_SendHTTPResponse( client, 302 );// moved temporarily
	responsecode = 302;
	WebSrv_ClientSendString( client, chUri );
	delete[] chUri;
	return 20;
}
