/********************************************************************************/
/*                                                                              */
/*  Netrinjo-Engine - a library for game-development                            */
/*  Copyright (C) 2005 by Tobias Nadler                                         */
/*                                                                              */
/*  This library is free software; you can redistribute it and/or               */
/*  modify it under the terms of the GNU Lesser General Public                  */
/*  License as published by the Free Software Foundation; either                */
/*  version 2.1 of the License, or (at your option) any later version.          */
/*                                                                              */
/*  This library is distributed in the hope that it will be useful,             */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/*  Lesser General Public License for more details.                             */
/*                                                                              */
/*  You should have received a copy of the GNU Lesser General Public            */
/*  License along with this library; if not, write to the Free Software         */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                              */
/********************************************************************************/

#include "webpage.h"
#include "webserver.h"

WebPage::WebPage( const char *uri )
{
	chURI = NULL;
	setURI( uri );
	WebServer::the->lPages.push_back( this );
}

WebPage::~WebPage()
{
	WebServer::the->lPages.remove( this );
	if( chURI )
		delete[] chURI;
}

int WebPage::send( WebSrvClient *client, Uint32 &responsecode )
{
	int r = 0;
	WebSrv_SendHTTPResponse( client, 204 );// no content
	responsecode = 204;
	r += sendString( client, "Content-Type: text/html\r\n\r\n" );
	r += sendString( client, "<h2>No initialized page</h2>\r\n" );
	r += sendString( client, "<p>This page does not contain any data.</p>" );
	return r;
}

void WebPage::setURI( const char *uri )
{
	if( chURI )
		delete[] chURI;
	if( uri == NULL )	{
		chURI = NULL;
		return;
	}
	
	chURI = new char[strlen(uri) + 1];
	strcpy( chURI, uri );
}

