/********************************************************************************/
/*                                                                              */
/*  Netrinjo-Engine - a library for game-development                            */
/*  Copyright (C) 2007 by Tobias Nadler                                         */
/*                                                                              */
/*  This library is free software; you can redistribute it and/or               */
/*  modify it under the terms of the GNU Lesser General Public                  */
/*  License as published by the Free Software Foundation; either                */
/*  version 2.1 of the License, or (at your option) any later version.          */
/*                                                                              */
/*  This library is distributed in the hope that it will be useful,             */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/*  Lesser General Public License for more details.                             */
/*                                                                              */
/*  You should have received a copy of the GNU Lesser General Public            */
/*  License along with this library; if not, write to the Free Software         */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                              */
/********************************************************************************/

#include "oglfunctions.h"

void ogl::drawLineLoop( GLint *x, GLint *y, unsigned int num, GLfloat width, GLint factor, GLushort pattern )
{
	glLineStipple( factor, pattern );
	glLineWidth( width );
	glDisable( GL_TEXTURE_2D );
	glBegin( GL_LINE_LOOP );
		for( unsigned int n = 0; n < num; n++ )
		{
			glVertex2i( *x++, *y++ );
		}
	glEnd();
	glEnable( GL_TEXTURE_2D );
}

void ogl::set2dClippingPlanes( SDL_Rect r )
{
	// pixels are drawn, when fulfilling the condition a*x + b*y + c*z + d >= 0
	enableClippingPlanes( 4 );
	GLdouble vdClip[4] = {1., 0., 0., -(GLdouble)r.x};
	glClipPlane( GL_CLIP_PLANE0, vdClip );
	vdClip[0] = -1.;
	vdClip[3] = (GLdouble)(r.x + r.w);
	glClipPlane( GL_CLIP_PLANE1, vdClip );
	vdClip[0] = 0.;
	vdClip[1] = 1.;
	vdClip[3] = -(GLdouble)r.y;
	glClipPlane( GL_CLIP_PLANE2, vdClip );
	vdClip[1] = -1.;
	vdClip[3] = (GLdouble)(r.y + r.h);
	glClipPlane( GL_CLIP_PLANE3, vdClip );
}

