/********************************************************************************/
/*                                                                              */
/*  Netrinjo-Engine - a library for game-development                            */
/*  Copyright (C) 2005 by Tobias Nadler                                         */
/*                                                                              */
/*  This library is free software; you can redistribute it and/or               */
/*  modify it under the terms of the GNU Lesser General Public                  */
/*  License as published by the Free Software Foundation; either                */
/*  version 2.1 of the License, or (at your option) any later version.          */
/*                                                                              */
/*  This library is distributed in the hope that it will be useful,             */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of              */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           */
/*  Lesser General Public License for more details.                             */
/*                                                                              */
/*  You should have received a copy of the GNU Lesser General Public            */
/*  License along with this library; if not, write to the Free Software         */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   */
/*                                                                              */
/********************************************************************************/

#include "sdlaudio.h"
#include <string.h>

#include "sdlmanager.h"
#include "basicapp.h"

SdlAudio::SdlAudio( const char *name )
{
	if( name != (char*)-1 )	{
		int n = strlen( name );
		chName = new char[n + 1];
		memcpy( chName, name, n );
		chName[n] = 0;

		SdlManager::the->lAudios.push_back( this );
	}
	else chName = 0;

	bFailed = false;

	cb = 0;
	cbData = 0;
}

SdlAudio::~SdlAudio()
{
	if( chName )	{
		delete chName;

		if( !bFailed )
			SdlManager::the->lAudios.remove( this );
		else
			SdlManager::the->lFailedAudios.remove( this );
	}
}

void SdlAudio::failed()
{
	if( chName )	{
		SdlManager::the->lAudios.remove( this );
		SdlManager::the->lFailedAudios.push_back( this );
		bFailed = true;
	}
}


void SdlAudio::rename( const char *newname )
{
	if( chName )	{
		delete chName;
	}
	else SdlManager::the->lAudios.push_back( this );

	int n = strlen( newname );
	chName = new char[n + 1];
	memcpy( chName, newname, n );
	chName[n] = 0;
}

void SdlAudio::setCallBack( CallBack c, void *pData )
{
	cb = c;
	cbData = pData;
}


